
#include <LiquidCrystal.h>
#include <SoftwareSerial.h>
#include <Wire.h>
#include <RTClib.h>
#include <Wire.h>


#include <LiquidCrystal_I2C.h>
DateTime now;
LiquidCrystal_I2C lcd(0x27,16,2);
SoftwareSerial mySerial(2, 3); // RX, TX
int h ;
int t ;
const int relayPin = 9; // پین مورد استفاده برای رله
enum {s1,s2,s3,s4,s5} state ;
const int YLsensorPin = A0;    // select the input pin for the potentiometer
int sensorValue ;  // variable to store the value coming from the sensor
char data ;
unsigned long timer;
const int buzzer = 13;
const int pump = 12;
const int heater = 11;
int TempSP;
int soilMoistureSP;
char str1[16];
char str2[16];
RTC_DS3231 rtc;
char p[32];
#include "DHT.h"
#define DHTPIN A1     // what pin we're connected to
#define DHTTYPE DHT11   // DHT 11  
DHT dht(DHTPIN, DHTTYPE);
void displayDate(void);


void displayTime(void);
void setup() {
   Serial.begin(9600);


 


  lcd.backlight();


  if (! rtc.begin()) 

    Serial.begin(9600);
  Wire.begin();
  rtc.begin();
  rtc.adjust(DateTime(F(__DATE__),F(__TIME__)));
  //rtc.adjust(DateTime(2019, 1, 21, 5, 0, 0));
   pinMode(relayPin, OUTPUT);
  attachInterrupt(0, increment, FALLING);
  data='0';
  state = s2;
  TempSP=0;
  soilMoistureSP=0;
  pinMode(heater, OUTPUT);
  pinMode(pump, OUTPUT);
  digitalWrite(heater, LOW);  
  digitalWrite(pump, LOW); 
  lcd.begin(16, 2);
  Serial.begin(9600);
  mySerial.begin(9600);
  dht.begin();
  StartLCD();
  
 
    Serial.println("DS1307 RTC Module not Present");


    while (1);
    
  if (rtc.lostPower()) 
  
    Serial.println("RTC power failure, resetting the time!");


    rtc.adjust(DateTime(F(__DATE__), F(__TIME__)));
}
  
void loop() {
   now = rtc.now();


  displayDate();


  displayTime();
    DateTime now = rtc.now();
  sprintf(p, "%02d:%02d:%02d %02d/%02d/%02d", now.hour(), now.minute(), now.second(), now.day(), now.month(), now.year());  
  Serial.print(F("Date/Time: "));
  Serial.println(p);
  delay(1000);
     if(t>TempSP+5)
   digitalWrite(relayPin, HIGH); // روشن کردن رله
  delay(1000); // توقف برای یک ثانیه
  digitalWrite(relayPin, LOW); // خاموش کردن رله
  delay(1000); // توقف برای یک ثانیه
  if (millis() > timer) {
  timer = millis() + 1000;
  sensorValue = analogRead(YLsensorPin);
  sensorValue = sensorValue/10.24 ; 
  h = dht.readHumidity();
  t = dht.readTemperature();
  
   if(state==s1)
   {
    digitalWrite(heater, LOW);  //heater 
    digitalWrite(pump, LOW);  //pump 
    }
   else 
   {
    if(t<TempSP)
    digitalWrite(heater, HIGH); 
    if(t>TempSP+5)
    digitalWrite(heater, LOW);
    if(sensorValue<soilMoistureSP)
    digitalWrite(pump,HIGH);
    if(sensorValue>soilMoistureSP+10)
    digitalWrite(pump,LOW); 
   }

//  if (isnan(t) || isnan(h)) {
//   Serial.println("Failed to read from DHT");
//  } 
//  else {
//   Serial.print("Humidity: "); 
//   Serial.print(h);
//   Serial.print(" %\t");
//   Serial.print("Temperature: "); 
//   Serial.print("DHT11 sensor = ");
//   Serial.print(t);
//   Serial.println(" *C");
//  }
}
 
switch (state)
 {
    case s1 :
     {
      lcd.setCursor(1,0);
      lcd.print("System Is OFF");
      delay(300);
      if(data=='1')
      {state=s2;lcd.clear();data='0';StartLCD();}
      delay(50);
      }
      break;
    
    case s2 : 
     {
      lcd.setCursor(0,0);
      sprintf(str1,"T:%2d H:%2d SM:%2d",t,h,sensorValue);
      lcd.print(str1);
      lcd.setCursor(15,0);
      lcd.print("%");
      lcd.setCursor(0,1);
     // lcd.print("TSP:");
     // lcd.print(TempSP);
     // lcd.setCursor(7,1);
     // sprintf(str2,"SMSP:%2d >",soilMoistureSP);
     // lcd.print(str2);
     lcd.print("data:");
     lcd.print(data);
      delay(300);
      if(data=='1'){state=s1;lcd.clear();data='0';StopLCD();}
      if(data=='>'){state=s3;lcd.clear();data='0';}
      delay(50);
      } 
      break;

      case s3 : 
     {
      lcd.setCursor(0,0);
      lcd.print("Chng Temp SP: ");
      lcd.print(TempSP);
      lcd.setCursor(0,1);
      lcd.print("< UP:+  DOWN:- >");
      delay(100);
      if(data=='1'){state=s1;lcd.clear();data='0';StopLCD();}
      if(data=='<')
      {state=s2;lcd.clear();data='0';}
      if(data=='>')
      {state=s4;lcd.clear();data='0';}
      if(data=='+')
      {TempSP=TempSP+1;lcd.clear();data='0';if(TempSP>50)TempSP=50;}
      if(data=='-')
      {TempSP=TempSP-1;lcd.clear();data='0'; if(TempSP<0)TempSP=0;}
      }
      break;
      
      case s4 : 
     { 
      lcd.setCursor(0,0);
      lcd.print("Chng SoilMSP:");
      lcd.print(soilMoistureSP);
      lcd.setCursor(0,1);
      lcd.print("< UP:+  DOWN:- ");
      delay(100);
      if(data=='1'){state=s1;lcd.clear();data='0';StopLCD();}
      if(data=='<')
      {state=s3;lcd.clear();data='0';}
      if(data=='+')
      {soilMoistureSP=soilMoistureSP+5;lcd.clear();data='0';}
      if(soilMoistureSP>90)
      {soilMoistureSP=90;}
      if(data=='-')
      {soilMoistureSP=soilMoistureSP-5;lcd.clear();data='0';}
      if(soilMoistureSP<0)
      {soilMoistureSP=0;}
      }
      break;
  } 

}
void increment(){
  if(mySerial.available() > 0)  // Send data only when you receive data:
  {
    data = mySerial.read();      //Read the incoming data and store it into variable data
  if(data=='1'){tone(buzzer,1000);delay(500);noTone(buzzer);}
  if(data=='<'){tone(buzzer,1000);delay(300);noTone(buzzer);}
  if(data=='>'){tone(buzzer,1000);delay(300);noTone(buzzer);}
  if(data=='+'){tone(buzzer,1000);delay(150);noTone(buzzer);}
  if(data=='-'){tone(buzzer,1000);delay(150);noTone(buzzer);}
  } 
  }
  
void StartLCD(){
 for(int i = 0 ; i<16 ; i++)
 {
  lcd.setCursor(i,0);
  lcd.write(255);
  lcd.setCursor(16-i,1);
  lcd.write(255);
  delay(100); 
 }
 lcd.clear();
}
void StopLCD(){
  for(int i = 0 ; i<16 ; i++)
 {
  lcd.setCursor(16-i,0);
  lcd.write(255);
  lcd.setCursor(i,1);
  lcd.write(255);
  delay(100); 
 }
 lcd.clear();
}
void displayTime()


 {


  lcd.setCursor(0,0);


  lcd.print("Time:");


  lcd.print(now.hour());


  lcd.print(':');


  lcd.print(now.minute());


  lcd.print(':');


  lcd.print(now.second());


  lcd.print("    ");


 }
  void displayDate()


 {


  lcd.setCursor(0,1);


  lcd.print("Date:");


  lcd.print(now.day());


  lcd.print('/');


  lcd.print(now.month());


  lcd.print('/');


  lcd.print(now.year());


 }

